Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 195)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 196)
@@ -124,6 +124,7 @@
 SUBROUTINE advect_u   ( u, u_old, tendency,            &
                         ru, rv, rom,                   &
-                        mut, config_flags,             &
-                        msfu, msfv, msft,              &
+                        mut, time_step, config_flags,  &
+                        msfu ,        msfv ,           &
+                        msft ,                         &
                         fzm, fzp,                      &
                         rdx, rdy, rdzw,                &
@@ -161,4 +162,5 @@
    REAL ,                                        INTENT(IN   ) :: rdx,  &
                                                                   rdy
+   INTEGER ,                                     INTENT(IN   ) :: time_step
 
    ! Local data
@@ -192,5 +194,5 @@
    flux3(q_im2, q_im1, q_i, q_ip1, ua) =                         &
             flux4(q_im2, q_im1, q_i, q_ip1, ua) +                &
-            sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
+            sign(1,time_step)*sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
 
    flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =           &
@@ -200,5 +202,5 @@
    flux5(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =           &
            flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua)     &
-            -sign(1.,ua)*(                              &
+            -sign(1,time_step)*sign(1.,ua)*(                     &
               (q_ip2-q_im3)-5.*(q_ip1-q_im2)+10.*(q_i-q_im1) )/60.0
 
@@ -227,21 +229,21 @@
 !   of the higher order flux stencils
 
-      degrade_xs = .true.
-      degrade_xe = .true.
-      degrade_ys = .true.
-      degrade_ye = .true.
-
-      IF( config_flags%periodic_x   .or. &
-          config_flags%symmetric_xs .or. &
-          (its > ids+2)                ) degrade_xs = .false.
-      IF( config_flags%periodic_x   .or. &
-          config_flags%symmetric_xe .or. &
-          (ite < ide-2)                ) degrade_xe = .false.
-      IF( config_flags%periodic_y   .or. &
-          config_flags%symmetric_ys .or. &
-          (jts > jds+2)                ) degrade_ys = .false.
-      IF( config_flags%periodic_y   .or. &
-          config_flags%symmetric_ye .or. &
-          (jte < jde-3)                ) degrade_ye = .false.
+   degrade_xs = .true.
+   degrade_xe = .true.
+   degrade_ys = .true.
+   degrade_ye = .true.
+
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xs .or. &
+       (its > ids+3)                ) degrade_xs = .false.
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xe .or. &
+       (ite < ide-2)                ) degrade_xe = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ys .or. &
+       (jts > jds+3)                ) degrade_ys = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ye .or. &
+       (jte < jde-4)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -273,4 +275,5 @@
       ENDIF
 
+
 !  compute fluxes, 5th or 6th order
 
@@ -280,59 +283,57 @@
      j_loop_y_flux_6 : DO j = j_start, j_end+1
 
-        IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN  ! use full stencil
-
-           DO k=kts,ktf
-           DO i = i_start, i_end
-              vel = 0.5*(rv(i,k,j)+rv(i-1,k,j))
-              fqy( i, k, jp1 ) = vel*flux6(                                &
-                                 u(i,k,j-3), u(i,k,j-2), u(i,k,j-1),       &
-                                 u(i,k,j  ), u(i,k,j+1), u(i,k,j+2),  vel )
-           ENDDO
-           ENDDO
+      IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN  ! use full stencil
+
+        DO k=kts,ktf
+        DO i = i_start, i_end
+          vel = 0.5*(rv(i,k,j)+rv(i-1,k,j))
+          fqy( i, k, jp1 ) = vel*flux6(               &
+                  u(i,k,j-3), u(i,k,j-2), u(i,k,j-1),       &
+                  u(i,k,j  ), u(i,k,j+1), u(i,k,j+2),  vel )
+        ENDDO
+        ENDDO
 
 !  we must be close to some boundary where we need to reduce the order of the stencil
 
-        ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
-
-           DO k=kts,ktf
-           DO i = i_start, i_end
+      ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
+
+            DO k=kts,ktf
+            DO i = i_start, i_end
               fqy(i, k, jp1) = 0.25*(rv(i,k,j)+rv(i-1,k,j))  &
-                                    *(u(i,k,j)+u(i,k,j-1))
-           ENDDO
-           ENDDO
-
-        ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
-
-           DO k=kts,ktf
-           DO i = i_start, i_end
+                                     *(u(i,k,j)+u(i,k,j-1))
+            ENDDO
+            ENDDO
+
+     ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
+
+            DO k=kts,ktf
+            DO i = i_start, i_end
               vel = 0.5*(rv(i,k,j)+rv(i-1,k,j))
               fqy( i, k, jp1 ) = vel*flux4(      &
                    u(i,k,j-2),u(i,k,j-1), u(i,k,j),u(i,k,j+1),vel )
-           ENDDO
-           ENDDO
-
-        ELSE IF ( j == jde-1 ) THEN  ! 2nd order flux next to north boundary
-
-           DO k=kts,ktf
-           DO i = i_start, i_end
+            ENDDO
+            ENDDO
+
+     ELSE IF ( j == jde-1 ) THEN  ! 2nd order flux next to north boundary
+
+            DO k=kts,ktf
+            DO i = i_start, i_end
               fqy(i, k, jp1) = 0.25*(rv(i,k,j)+rv(i-1,k,j))    &
                      *(u(i,k,j)+u(i,k,j-1))
-           ENDDO
-           ENDDO
-
-        ELSE IF ( j == jde-2 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
-
-           DO k=kts,ktf
-           DO i = i_start, i_end
+            ENDDO
+            ENDDO
+
+     ELSE IF ( j == jde-2 ) THEN  ! 3rd order flux 2 in from north boundary
+
+            DO k=kts,ktf
+            DO i = i_start, i_end
               vel = 0.5*(rv(i,k,j)+rv(i-1,k,j))
               fqy( i, k, jp1 ) = vel*flux4(     &
                    u(i,k,j-2),u(i,k,j-1),    &
                    u(i,k,j),u(i,k,j+1),vel )
-           ENDDO
-           ENDDO
-
-        END IF
-
-!stopped
+            ENDDO
+            ENDDO
+
+      END IF
 
 !  y flux-divergence into tendency
@@ -348,4 +349,5 @@
 
         ENDIF
+
 
 
@@ -475,5 +477,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+2)                ) degrade_xs = .false.
+       (its > ids+3)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -481,8 +483,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+2)                ) degrade_ys = .false.
+       (jts > jds+3)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-3)                ) degrade_ye = .false.
+       (jte < jde-4)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -514,4 +516,5 @@
       ENDIF
 
+
 !  compute fluxes, 5th or 6th order
 
@@ -562,5 +565,5 @@
             ENDDO
 
-     ELSE IF ( j == jde-2 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
+     ELSE IF ( j == jde-2 ) THEN  ! 3rd order flux 2 in from north boundary
 
             DO k=kts,ktf
@@ -587,4 +590,5 @@
 
         ENDIF
+
 
 
@@ -709,5 +713,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -715,8 +719,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
+       (jte < jde-3)                ) degrade_ye = .false.
 
 !--------------- x - advection first
@@ -817,4 +821,5 @@
         j_end_f = jde-2
       ENDIF
+
 
 !  j flux loop for v flux of u momentum
@@ -835,6 +840,9 @@
        DO k = kts, ktf
        DO i = i_start, i_end
-         fqy(i, k, jp1) = 0.25*(rv(i,k,j_end+1)+rv(i-1,k,j_end+1))    &
-                *(u(i,k,j_end+1)+u(i,k,j_end))
+         ! Assumes j>j_end_f is ONLY j_end+1 ...
+!         fqy(i, k, jp1) = 0.25*(rv(i,k,j_end+1)+rv(i-1,k,j_end+1))    &
+!                *(u(i,k,j_end+1)+u(i,k,j_end))
+         fqy(i, k, jp1) = 0.25*(rv(i,k,j)+rv(i-1,k,j))    &
+                *(u(i,k,j)+u(i,k,j-1))
        ENDDO
        ENDDO
@@ -852,7 +860,7 @@
      END IF
 
+!  y flux-divergence into tendency
+
      IF (j > j_start) THEN
-
-!  y flux-divergence into tendency
 
        DO k=kts,ktf
@@ -865,4 +873,5 @@
      END IF
 
+
      jtmp = jp1
      jp1 = jp0
@@ -890,5 +899,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -896,8 +905,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
+       (jte < jde-3)                ) degrade_ye = .false.
 
 !--------------- x - advection first
@@ -997,4 +1006,5 @@
         j_end_f = jde-2
       ENDIF
+
 
 !  j flux loop for v flux of u momentum
@@ -1015,6 +1025,9 @@
        DO k = kts, ktf
        DO i = i_start, i_end
-         fqy(i, k, jp1) = 0.25*(rv(i,k,j_end+1)+rv(i-1,k,j_end+1))    &
-                *(u(i,k,j_end+1)+u(i,k,j_end))
+         ! Assumes j>j_end_f is ONLY j_end+1 ...
+!         fqy(i, k, jp1) = 0.25*(rv(i,k,j_end+1)+rv(i-1,k,j_end+1))    &
+!                *(u(i,k,j_end+1)+u(i,k,j_end))
+         fqy(i, k, jp1) = 0.25*(rv(i,k,j)+rv(i-1,k,j))    &
+                *(u(i,k,j)+u(i,k,j-1))
        ENDDO
        ENDDO
@@ -1032,7 +1045,7 @@
      END IF
 
+!  y flux-divergence into tendency
+
      IF (j > j_start) THEN
-
-!  y flux-divergence into tendency
 
        DO k=kts,ktf
@@ -1044,4 +1057,5 @@
 
      END IF
+
 
      jtmp = jp1
@@ -1116,4 +1130,8 @@
       ENDDO
       ENDDO
+
+   ELSE IF ( horz_order == 0 ) THEN
+
+      ! Just in case we want to turn horizontal advection off, we can do it
 
    ELSE
@@ -1410,5 +1428,5 @@
 SUBROUTINE advect_v   ( v, v_old, tendency,            &
                         ru, rv, rom,                   &
-                        mut, config_flags,             &
+                        mut, time_step, config_flags,  &
                         msfu, msfv, msft,              &
                         fzm, fzp,                      &
@@ -1447,4 +1465,6 @@
    REAL ,                                        INTENT(IN   ) :: rdx,  &
                                                                   rdy
+   INTEGER ,                                     INTENT(IN   ) :: time_step
+
 
    ! Local data
@@ -1481,5 +1501,5 @@
    flux3(q_im2, q_im1, q_i, q_ip1, ua) =                     &
            flux4(q_im2, q_im1, q_i, q_ip1, ua) +                &
-           sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
+           sign(1,time_step)*sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
 
    flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =       &
@@ -1489,5 +1509,5 @@
    flux5(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =       &
            flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua)    &
-            -sign(1.,ua)*(                             &
+            -sign(1,time_step)*sign(1.,ua)*(                    &
               (q_ip2-q_im3)-5.*(q_ip1-q_im2)+10.*(q_i-q_im1) )/60.0
 
@@ -1518,25 +1538,23 @@
 !   of the higher order flux stencils
 
-      degrade_xs = .true.
-      degrade_xe = .true.
-      degrade_ys = .true.
-      degrade_ye = .true.
-
-      IF( config_flags%periodic_x   .or. &
-          config_flags%symmetric_xs .or. &
-          (its > ids+2)                ) degrade_xs = .false.
-      IF( config_flags%periodic_x   .or. &
-          config_flags%symmetric_xe .or. &
-          (ite < ide-3)                ) degrade_xe = .false.
-      IF( config_flags%periodic_y   .or. &
-          config_flags%symmetric_ys .or. &
-          (jts > jds+2)                ) degrade_ys = .false.
-      IF( config_flags%periodic_y   .or. &
-          config_flags%symmetric_ye .or. &
-          (jte < jde-2)                ) degrade_ye = .false.
+   degrade_xs = .true.
+   degrade_xe = .true.
+   degrade_ys = .true.
+   degrade_ye = .true.
+
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xs .or. &
+       (its > ids+3)                ) degrade_xs = .false.
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xe .or. &
+       (ite < ide-3)                ) degrade_xe = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ys .or. &
+       (jts > jds+3)                ) degrade_ys = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ye .or. &
+       (jte < jde-3)                ) degrade_ye = .false.
 
 !--------------- y - advection first
-
-      ktf=MIN(kte,kde-1)
 
       i_start = its
@@ -1552,35 +1570,35 @@
 
       IF(degrade_ys) then
-         j_start = MAX(jts,jds+1)
-         j_start_f = jds+3
+        j_start = MAX(jts,jds+1)
+        j_start_f = jds+3
       ENDIF
 
       IF(degrade_ye) then
-         j_end = MIN(jte,jde-1)
-         j_end_f = jde-2
+        j_end = MIN(jte,jde-1)
+        j_end_f = jde-2
       ENDIF
 
 !  compute fluxes, 5th or 6th order
 
-      jp1 = 2
-      jp0 = 1
-
-      j_loop_y_flux_6 : DO j = j_start, j_end+1
-
-         IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN
-
-            DO k=kts,ktf
-            DO i = i_start, i_end
-               vel = 0.5*(rv(i,k,j)+rv(i,k,j-1))
-               fqy( i, k, jp1 ) = vel*flux6(                                &
-                                  v(i,k,j-3), v(i,k,j-2), v(i,k,j-1),       &
-                                  v(i,k,j  ), v(i,k,j+1), v(i,k,j+2),  vel )
-            ENDDO
-            ENDDO
+     jp1 = 2
+     jp0 = 1
+
+     j_loop_y_flux_6 : DO j = j_start, j_end+1
+
+      IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN
+
+        DO k=kts,ktf
+        DO i = i_start, i_end
+          vel = 0.5*(rv(i,k,j)+rv(i,k,j-1))
+          fqy( i, k, jp1 ) = vel*flux6(               &
+                  v(i,k,j-3), v(i,k,j-2), v(i,k,j-1),       &
+                  v(i,k,j  ), v(i,k,j+1), v(i,k,j+2),  vel )
+        ENDDO
+        ENDDO
 
 !  we must be close to some boundary where we need to reduce the order of the stencil
 !  specified uses upstream normal wind at boundaries
 
-         ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
+      ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
 
             DO k=kts,ktf
@@ -1593,16 +1611,16 @@
             ENDDO
 
-         ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
+     ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
 
             DO k=kts,ktf
             DO i = i_start, i_end
-                vel = 0.5*(rv(i,k,j)+rv(i,k,j-1))
-                fqy( i, k, jp1 ) = vel*flux4(      &
-                                   v(i,k,j-2),v(i,k,j-1),v(i,k,j),v(i,k,j+1),vel )
-            ENDDO
-            ENDDO
-
-
-         ELSE IF ( j == jde ) THEN  ! 2nd order flux next to north boundary
+              vel = 0.5*(rv(i,k,j)+rv(i,k,j-1))
+              fqy( i, k, jp1 ) = vel*flux4(      &
+                   v(i,k,j-2),v(i,k,j-1),v(i,k,j),v(i,k,j+1),vel )
+            ENDDO
+            ENDDO
+
+
+     ELSE IF ( j == jde ) THEN  ! 2nd order flux next to north boundary
 
             DO k=kts,ktf
@@ -1615,34 +1633,37 @@
             ENDDO
 
-         ELSE IF ( j == jde-1 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
+     ELSE IF ( j == jde-1 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
 
             DO k=kts,ktf
             DO i = i_start, i_end
-                vel = 0.5*(rv(i,k,j)+rv(i,k,j-1))
-                fqy( i, k, jp1 ) = vel*flux4(     &
-                                   v(i,k,j-2),v(i,k,j-1),v(i,k,j),v(i,k,j+1),vel )
-            ENDDO
-            ENDDO
-
-         END IF
+              vel = 0.5*(rv(i,k,j)+rv(i,k,j-1))
+              fqy( i, k, jp1 ) = vel*flux4(     &
+                   v(i,k,j-2),v(i,k,j-1),v(i,k,j),v(i,k,j+1),vel )
+            ENDDO
+            ENDDO
+
+      END IF
 
 !  y flux-divergence into tendency
 
-         IF(j > j_start) THEN
-
-            DO k=kts,ktf
-            DO i = i_start, i_end
-               mrdy=msfv(i,j-1)*rdy
-               tendency(i,k,j-1) = tendency(i,k,j-1) - mrdy*(fqy(i,k,jp1)-fqy(i,k,jp0))
-            ENDDO
-            ENDDO
-
-         ENDIF
-
-         jtmp = jp1
-         jp1 = jp0
-         jp0 = jtmp
-
-      ENDDO j_loop_y_flux_6
+
+        IF(j > j_start) THEN
+
+          DO k=kts,ktf
+          DO i = i_start, i_end
+            mrdy=msfv(i,j-1)*rdy
+            tendency(i,k,j-1) = tendency(i,k,j-1) - mrdy*(fqy(i,k,jp1)-fqy(i,k,jp0))
+          ENDDO
+          ENDDO
+
+        ENDIF
+
+
+
+        jtmp = jp1
+        jp1 = jp0
+        jp0 = jtmp
+
+   ENDDO j_loop_y_flux_6
 
 !  next, x - flux divergence
@@ -1653,4 +1674,5 @@
       j_start = jts
       j_end   = jte
+
       IF ( config_flags%open_ys .or. specified ) j_start = MAX(jds+1,jts)
       IF ( config_flags%open_ye .or. specified ) j_end   = MIN(jde-1,jte)
@@ -1663,11 +1685,12 @@
 
       IF(degrade_xs) then
-         i_start = MAX(ids+1,its)
-         i_start_f = i_start+2
+        i_start = MAX(ids+1,its)
+!        i_start_f = i_start+2
+        i_start_f = MIN(i_start+2,ids+3)
       ENDIF
 
       IF(degrade_xe) then
-         i_end = MIN(ide-2,ite)
-         i_end_f = ide-3
+        i_end = MIN(ide-2,ite)
+        i_end_f = ide-3
       ENDIF
 
@@ -1678,66 +1701,74 @@
 !  5th or 6th order flux
 
-         DO k=kts,ktf
-         DO i = i_start_f, i_end_f
-            vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
-            fqx( i, k ) = vel*flux6( v(i-3,k,j), v(i-2,k,j),  &
-                                     v(i-1,k,j), v(i  ,k,j),  &
-                                     v(i+1,k,j), v(i+2,k,j),  &
-                                     vel                     )
-         ENDDO
-         ENDDO
+        DO k=kts,ktf
+        DO i = i_start_f, i_end_f
+          vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
+          fqx( i, k ) = vel*flux6( v(i-3,k,j), v(i-2,k,j),  &
+                                         v(i-1,k,j), v(i  ,k,j),  &
+                                         v(i+1,k,j), v(i+2,k,j),  &
+                                         vel                     )
+        ENDDO
+        ENDDO
 
 !  lower order fluxes close to boundaries (if not periodic or symmetric)
 
-         IF( degrade_xs ) THEN
-
-            IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-               i = ids+1
-               DO k=kts,ktf
-                  fqx(i,k) = 0.25*(ru(i,k,j)+ru(i,k,j-1)) &
-                                 *(v(i,k,j)+v(i-1,k,j))
-               ENDDO
+        IF( degrade_xs ) THEN
+
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts,ktf
+                fqx(i,k) = 0.25*(ru(i,k,j)+ru(i,k,j-1)) &
+                                *(v(i,k,j)+v(i-1,k,j))
+              ENDDO
             ENDIF
 
-            i = ids+2
-            DO k=kts,ktf
-               vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
-               fqx( i,k ) = vel*flux4( v(i-2,k,j), v(i-1,k,j),  &
-                                       v(i  ,k,j), v(i+1,k,j),  &
-                                       vel                     )
-            ENDDO
-
-         ENDIF
-
-         IF( degrade_xe ) THEN
-
-            IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-               i = ide-1
-               DO k=kts,ktf
-                  fqx(i,k) = 0.25*(ru(i_end+1,k,j)+ru(i_end+1,k,j-1))      &
-                                 *(v(i_end+1,k,j)+v(i_end,k,j))
-               ENDDO
+            IF(i == ids+2) THEN  ! third order
+              DO k=kts,ktf
+                vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
+                fqx( i,k ) = vel*flux4( v(i-2,k,j), v(i-1,k,j),  &
+                                        v(i  ,k,j), v(i+1,k,j),  &
+                                        vel                     )
+              ENDDO
             ENDIF
 
-            i = ide-2
-            DO k=kts,ktf
-               vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
-               fqx( i,k ) = vel*flux4( v(i-2,k,j), v(i-1,k,j),  &
-                                       v(i  ,k,j), v(i+1,k,j),  &
-                                       vel                     )
-            ENDDO
-
-         ENDIF
+          ENDDO
+
+        ENDIF
+
+        IF( degrade_xe ) THEN
+
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts,ktf
+                fqx(i,k) = 0.25*(ru(i_end+1,k,j)+ru(i_end+1,k,j-1))      &
+                                *(v(i_end+1,k,j)+v(i_end,k,j))
+              ENDDO
+            ENDIF
+
+            IF( i == ide-2 ) THEN ! third order flux one in from the boundary
+              DO k=kts,ktf
+                vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
+                fqx( i,k ) = vel*flux4( v(i-2,k,j), v(i-1,k,j),  &
+                                        v(i  ,k,j), v(i+1,k,j),  &
+                                        vel                     )
+              ENDDO
+            ENDIF
+
+          ENDDO
+
+        ENDIF
 
 !  x flux-divergence into tendency
 
-         DO k=kts,ktf
-            DO i = i_start, i_end
+        DO k=kts,ktf
+          DO i = i_start, i_end
             mrdx=msfv(i,j)*rdx
             tendency(i,k,j) = tendency(i,k,j) - mrdx*(fqx(i+1,k)-fqx(i,k))
-         ENDDO
-      ENDDO
-
-   ENDDO
+          ENDDO
+        ENDDO
+
+      ENDDO
 
    ELSE IF( horz_order == 5 ) THEN
@@ -1762,5 +1793,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+2)                ) degrade_xs = .false.
+       (its > ids+3)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -1768,8 +1799,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+2)                ) degrade_ys = .false.
+       (jts > jds+3)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
+       (jte < jde-3)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -1875,4 +1906,5 @@
         ENDIF
 
+
         jtmp = jp1
         jp1 = jp0
@@ -1899,5 +1931,6 @@
       IF(degrade_xs) then
         i_start = MAX(ids+1,its)
-        i_start_f = i_start+2
+!        i_start_f = i_start+2
+        i_start_f = MIN(i_start+2,ids+3)
       ENDIF
 
@@ -1927,38 +1960,46 @@
         IF( degrade_xs ) THEN
 
-          IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-            i = ids+1
-            DO k=kts,ktf
-            fqx(i,k) = 0.25*(ru(i,k,j)+ru(i,k,j-1)) &
-                   *(v(i,k,j)+v(i-1,k,j))
-            ENDDO
-         ENDIF
-
-          i = ids+2
-          DO k=kts,ktf
-            vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
-            fqx( i,k ) = vel*flux3( v(i-2,k,j), v(i-1,k,j),  &
-                                          v(i  ,k,j), v(i+1,k,j),  &
-                                          vel                     )
-          ENDDO
-
-        ENDIF
-
-        IF( degrade_xe ) THEN
-
-          IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-            i = ide-1
-            DO k=kts,ktf
-              fqx(i,k) = 0.25*(ru(i_end+1,k,j)+ru(i_end+1,k,j-1))      &
-                              *(v(i_end+1,k,j)+v(i_end,k,j))
-            ENDDO
-          ENDIF
-
-          i = ide-2
-          DO k=kts,ktf
-          vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
-          fqx( i,k ) = vel*flux3( v(i-2,k,j), v(i-1,k,j),  &
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts,ktf
+                fqx(i,k) = 0.25*(ru(i,k,j)+ru(i,k,j-1)) &
+                                *(v(i,k,j)+v(i-1,k,j))
+              ENDDO
+            ENDIF
+
+            IF(i == ids+2) THEN  ! third order
+              DO k=kts,ktf
+                vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
+                fqx( i,k ) = vel*flux3( v(i-2,k,j), v(i-1,k,j),  &
                                         v(i  ,k,j), v(i+1,k,j),  &
                                         vel                     )
+              ENDDO
+            ENDIF
+
+          ENDDO
+
+        ENDIF
+
+        IF( degrade_xe ) THEN
+
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts,ktf
+                fqx(i,k) = 0.25*(ru(i_end+1,k,j)+ru(i_end+1,k,j-1))      &
+                                *(v(i_end+1,k,j)+v(i_end,k,j))
+              ENDDO
+            ENDIF
+
+            IF( i == ide-2 ) THEN ! third order flux one in from the boundary
+              DO k=kts,ktf
+                vel = 0.5*(ru(i,k,j)+ru(i,k,j-1))
+                fqx( i,k ) = vel*flux3( v(i-2,k,j), v(i-1,k,j),  &
+                                        v(i  ,k,j), v(i+1,k,j),  &
+                                        vel                     )
+              ENDDO
+            ENDIF
+
           ENDDO
 
@@ -1992,5 +2033,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -1998,8 +2039,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-1)                ) degrade_ye = .false.
+       (jte < jde-2)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -2074,4 +2115,6 @@
         ENDDO
         ENDDO
+
+
       END IF
 
@@ -2167,5 +2210,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -2173,8 +2216,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-1)                ) degrade_ye = .false.
+       (jte < jde-2)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -2249,4 +2292,6 @@
         ENDDO
         ENDDO
+
+
       END IF
 
@@ -2405,4 +2450,8 @@
       ENDDO
       ENDDO
+
+   ELSE IF ( horz_order == 0 ) THEN
+
+      ! Just in case we want to turn horizontal advection off, we can do it
 
   ELSE
@@ -2530,4 +2579,6 @@
       ENDDO
 
+      !
+      !
       IF ( config_flags%open_ys .or. specified ) j_start = MAX(jds+1,jts)
       IF ( config_flags%open_ye .or. specified ) j_end   = MIN(jde-1,jte)
@@ -2570,4 +2621,6 @@
          DO k=kts,ktf
          DO i = i_start, i_end
+            !
+            !
             tendency(i,k,j)=tendency(i,k,j)-rdzw(k)*(vflux(i,k+1)-vflux(i,k))
          ENDDO
@@ -2613,4 +2666,6 @@
          DO k=kts,ktf
          DO i = i_start, i_end
+            !
+            !
             tendency(i,k,j)=tendency(i,k,j)-rdzw(k)*(vflux(i,k+1)-vflux(i,k))
          ENDDO
@@ -2646,4 +2701,6 @@
          DO k=kts,ktf
          DO i = i_start, i_end
+            !
+            !
             tendency(i,k,j)=tendency(i,k,j)-rdzw(k)*(vflux(i,k+1)-vflux(i,k))
          ENDDO
@@ -2679,4 +2736,6 @@
          DO k=kts,ktf
          DO i = i_start, i_end
+            !
+            !
             tendency(i,k,j)=tendency(i,k,j)-rdzw(k)*(vflux(i,k+1)-vflux(i,k))
          ENDDO
@@ -2699,6 +2758,7 @@
       DO k=kts,ktf
       DO i = i_start, i_end
+            !
+            !
             tendency(i,k,j)=tendency(i,k,j)-rdzw(k)*(vflux(i,k+1)-vflux(i,k))
-
       ENDDO
       ENDDO
@@ -2718,5 +2778,5 @@
 SUBROUTINE advect_scalar   ( field, field_old, tendency,    &
                              ru, rv, rom,                   &
-                             mut, config_flags,             &
+                             mut, time_step, config_flags,  &
                              msfu, msfv, msft,              &
                              fzm, fzp,                      &
@@ -2755,4 +2815,6 @@
    REAL ,                                        INTENT(IN   ) :: rdx,  &
                                                                   rdy
+   INTEGER ,                                     INTENT(IN   ) :: time_step
+
 
    ! Local data
@@ -2788,5 +2850,5 @@
       flux3(q_im2, q_im1, q_i, q_ip1, ua) =                     &
            flux4(q_im2, q_im1, q_i, q_ip1, ua) +                &
-           sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
+           sign(1,time_step)*sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
 
       flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =       &
@@ -2796,5 +2858,5 @@
       flux5(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =       &
            flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua)    &
-            -sign(1.,ua)*(                             &
+            -sign(1,time_step)*sign(1.,ua)*(                    &
               (q_ip2-q_im3)-5.*(q_ip1-q_im2)+10.*(q_i-q_im1) )/60.0
 
@@ -2831,5 +2893,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+2)                ) degrade_xs = .false.
+       (its > ids+3)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -2837,8 +2899,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+2)                ) degrade_ys = .false.
+       (jts > jds+3)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-3)                ) degrade_ye = .false.
+       (jte < jde-4)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -2865,4 +2927,5 @@
         j_end_f = jde-3
       ENDIF
+
 
 !  compute fluxes, 5th or 6th order
